package com.i2asolutions.admob;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;

import android.util.Log;
import android.view.animation.AlphaAnimation;

import com.aerserv.sdk.AerServBanner;
import com.aerserv.sdk.AerServConfig;
import com.aerserv.sdk.AerServEvent;
import com.aerserv.sdk.AerServEventListener;
import com.google.android.gms.ads.AdSize;
import com.google.android.gms.ads.mediation.MediationAdRequest;
import com.google.android.gms.ads.mediation.customevent.CustomEventBanner;
import com.google.android.gms.ads.mediation.customevent.CustomEventBannerListener;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by adrian on 15.05.2015.
 */
public final class AdmobCustomEventBanner implements CustomEventBanner {

    //Banner Adapter
    private AerServBanner banner;


    @Override
    public void requestBannerAd(Context context, CustomEventBannerListener customEventBannerListener,
                                String s, AdSize adSize, MediationAdRequest mediationAdRequest, Bundle bundle) {

        Log.i("1000308:", s);

        List<String> a;
        if(mediationAdRequest.getKeywords() != null)
        {
            a = new ArrayList<String>(mediationAdRequest.getKeywords());
        }
        else
        {
            a = new ArrayList<String>();
        }
        banner = new AerServBanner(context);
        final AerServConfig config = new AerServConfig(context, "1003245").setKeywords(a)
                .setEventListener(new AerservBannerAdapter(context, customEventBannerListener)).setDebug(true);

        banner.configure(config);
        banner.show();
        customEventBannerListener.onAdLoaded(banner);
    }

    @Override
    public void onDestroy() {
        if(banner != null)
        {
            banner.kill();
        }

    }

    @Override
    public void onPause() {
        if(banner != null)
        {
            banner.pause();
        }

    }

    @Override
    public void onResume() {
        if(banner != null)
        {
            banner.play();
        }
    }


    private class AerservBannerAdapter implements AerServEventListener {

        private Context context;
        private CustomEventBannerListener listener;

        public AerservBannerAdapter(Context context, CustomEventBannerListener listener)
        {

            this.listener = listener;
            this.context = context;
        }

        @Override
        public void onAerServEvent(final AerServEvent aerServEvent, final List<Object> list) {
            if(context != null)
            {
                ((MainActivity) context).runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        switch (aerServEvent)
                        {
                            case AD_LOADED:

                                break;
                            case AD_CLICKED:
                                listener.onAdClicked();
                                listener.onAdLeftApplication();
                                break;

                            case AD_COMPLETED:
                                listener.onAdClosed();
                                break;

                            case AD_FAILED:
                                Log.i("ADAPTER AERSERV:", list.get(0).toString());
                                listener.onAdFailedToLoad(-1);
                                break;

                            case AD_DISMISSED:
                                listener.onAdClosed();
                                break;

                            case PRELOAD_READY:

                        }
                    }
                });
            }
        }
    }
}